#!/bin/csh
if ( $#argv != 3 ) then
  echo usage: buildffftw.csh fine_grid_size number_of_nodes number_of_cpu_per_node 
else
  switch (`uname -m`)
  case i686 :
    set USEMAKE = "MakeIA32"
    breaksw
  case ia64 :
    set USEMAKE = "MakeIA64"
    breaksw
  endsw
  @ NUMCPUPN = $3
  @ NUMNODES = $2 
  @ FGSIZE = $1
  @ FGBUFSIZE = 24
  @ CGSIZE = $2 * ($FGSIZE - 2 * $FGBUFSIZE) / 4 
  echo building filefftw:
  echo number of nodes: $NUMNODES
  echo number of cpu per node: $NUMCPUPN
  echo fine grid size: $FGSIZE
  echo coarse grid size: $CGSIZE 
  make clean -f $USEMAKE
  set DN2 = "-DDEFN2="$CGSIZE 
  set DNN = "-DDEFNN="$NUMNODES
  set DNC = "-DDEFNCPU="$NUMCPUPN
  cp $USEMAKE Makefile
  perl -p -e "s/dummy1/"$DN2"/g" ./Makefile > ./Maketemp
  rm -f Makefile
  perl -p -e "s/dummy3/"$DNC"/g" ./Maketemp > ./Makefile
  rm -f Maketemp
  perl -p -e "s/dummy2/"$DNN"/g" ./Makefile > ./Maketemp
  mv -f Maketemp Makefile
  make -j4 
  rm -f Makefile Maketemp
  unset NUMPROCS
  unset NUMCPUPN
  unset FGSIZE
  unset FGBUFSIZE
  unset CGSIZE
  unset USEMAKE
endif
exit 0
