!************************************************
! linklist.f90 - construct linklist for particles
! Copyright (C) 2004 Hugh Merz - merz@cita.utoronto.ca
! latest revision Feb 11 2004
!***********************************************************
!This program is free software; you can redistribute it and/or
!modify it under the terms of the GNU General Public License
!as published by the Free Software Foundation; either version 2
!of the License, or (at your option) any later version.
!
!This program is distributed in the hope that it will be useful,
!but WITHOUT ANY WARRANTY; without even the implied warranty of
!MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!GNU General Public License for more details.
!
!You should have received a copy of the GNU General Public License
!along with this program; if not, write to the Free Software
!Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

subroutine link_list
  implicit none
  include 'globalpm.fh'

  integer(kind=4) :: thrdnum,i,j,k,ip,in
  integer(kind=4) :: omp_get_thread_num,omp_get_num_threads
  external omp_get_thread_num,omp_get_num_threads

!! initial hoc and toc

  !$omp parallel default(shared) private(i,j,k,ip,in,thrdnum)
  if (omp_get_num_threads().ne.NT) &
     write(*,*) 'incorrect num threads in link_list'
  thrdnum=1
  !$ thrdnum=omp_get_thread_num()+1
  do k=HOCZL,HOCZH
    do j=1,LC
      do i=1,LC
        hoc(i,j,k,thrdnum)=0
        toc(i,j,k,thrdnum)=0
      enddo
    enddo
  enddo

!! construct each threads link list

  ndel(thrdnum)=0  

  !$omp do
  do ip=1,nploc
    i=floor(0.25*xvp(1,ip))+1
    j=floor(0.25*xvp(2,ip))+1
    k=floor(0.25*xvp(3,ip))+1

!! this is a precaution to avoid cases where particles
!! appear where they should not

    if (k.lt.HOCZL.or.k.gt.HOCZH) then

#ifdef DIAG
      write(*,*) 'particle out of link list range,deleted'
      write(*,*) xvp(:,ip),ip,k,HOCZL,HOCZH
#endif

!!!!! THIS IS INCORRECT!!! nploc is a shared variable!!!
!      xvp(:,ip)=xvp(:,nploc)
!      nploc=nploc-1
!      i=floor(0.25*xvp(1,ip))+1
!      j=floor(0.25*xvp(2,ip))+1
!      k=floor(0.25*xvp(3,ip))+1
!!!!!
      ndel(thrdnum)=ndel(thrdnum)+1
      dellist(ndel(thrdnum),thrdnum)=ip
    else
      if (hoc(i,j,k,thrdnum).eq.0) toc(i,j,k,thrdnum)=ip
      ll(ip)=hoc(i,j,k,thrdnum)
      hoc(i,j,k,thrdnum)=ip
    endif
  enddo
  !$omp end do

!! merge into single list

  !$omp do
  do k=HOCZL,HOCZH
    do j=1,LC
      do i=1,LC
        do in=2,NT
          if (hoc(i,j,k,in).ne.0) then
            ll(toc(i,j,k,in))=hoc(i,j,k,1)
            hoc(i,j,k,1)=hoc(i,j,k,in)
          endif
        enddo
      enddo
    enddo
  enddo
  !$omp end do
  !$omp end parallel

end subroutine link_list
