! slice_proj.f90 - samples a checkpoint file and produces a 
! particle distribution from a thin slice of the original volume

implicit none

   character(len=*) :: ifile='xvp0.dat'
   character(len=*) :: ofile='xy_slice.dat'
   real(kind=4), parameter :: z_lb = 5.0  !lower bound of slice
   real(kind=4), parameter :: z_ub = 6.0  !upper bound of slice

   real(kind=4), dimension(6) :: xv
   integer(kind=4) :: i,j,nploc
   real(kind=4) :: z

   open (unit=13,file=ifile,form='binary')
   read(13) nploc

   open (unit=11,file=ofile,form='formatted')

   do j=1,nploc
     read(13) xv
     if (xv(3).ge.z_lb.and.xv(3).lt.z_ub)  &
         write(11,'(3f20.10)') xv(1),xv(2),xv(3)
   enddo

   close(13)
   close(11)

end 
